VERSION 5.00
Begin VB.Form FrmD3d 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   213
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "FrmD3d"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim DX As New DX3D
Dim DxLogo As DirectDrawSurface7
Dim DxVert(3) As D3DTLVERTEX
Dim Xangle As Integer
Dim SpriteSurf As DirectDrawSurface7
Dim SpriteVert(1 To 5) As Vert
Dim FlareSurf As DirectDrawSurface7
Dim FloorSurf As DirectDrawSurface7
Dim CloudVert(1 To 10) As Vert
Dim Cangle As Double
Dim temp As Integer
Const PI = 3.14159

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = vbKeyEscape Then
DX.EndDX FrmD3d
UnloadSurfaces
End
End If
End Sub

Public Function InitSurfaces()
Set DxLogo = DX.CreateTextureSurface(App.Path & "\D3D.bmp", 128, 128, 1)
Set FlareSurf = DX.CreateTextureSurface(App.Path & "\Flare.bmp", 128, 128)
Set FloorSurf = DX.CreateTextureSurface(App.Path & "\Floor.bmp", 128, 128, 1)

End Function

Private Sub Form_Load()
DX.InitializeDX FrmD3d, 640, 480, 16
InitSurfaces '// Load all the textures
InitLighting
MainLoop
End Sub

Public Function UnloadSurfaces()
Set DxLogo = Nothing
End Function


Public Function DoMath()
Dim I As Integer
DoLighting
temp = temp + 1
If temp >= 3 Then
temp = 0
Cangle = Cangle + 10 * PI / 180
Xangle = Xangle + 1
If Xangle >= 35 Then: Xangle = 0: Cangle = 0
End If
End Function

Public Function MainLoop()
Dim I As Integer
For I = 1 To 10
CloudVert(I).X = 640 * Rnd
CloudVert(I).Y = 480 * Rnd
Next I
Do
SetVertexes '// Set vertexes for color lights
DoMath
BLT
DX.DDFlip '// Flip the backbuffer to the frontbuffer
DoEvents
Loop
End Function

Public Function SetVertexes()
Dim X As Integer
Dim Y As Integer
Dim I As Integer
ISoRotateVertex TileVert(1).Vertex(), 320 - 40, 50 + 50, 100, 100, 1, , , DX.DX.CreateColorRGBA(Red(1), 0, 0, Alpha(2))
ISoRotateVertex TileVert(2).Vertex(), 220 - 40, 150 + 50, 100, 100, 2, DX.DX.CreateColorRGBA(Red(1), 0, 0, Alpha(2)), DX.DX.CreateColorRGBA(Red(0), 0, 0, Alpha(3))
ISoRotateVertex TileVert(3).Vertex(), 420 - 40, 200 + 50, 100, 100, 3, DX.DX.CreateColorRGBA(Red(1), 0, 0, Alpha(2)), DX.DX.CreateColorRGBA(Red(0), 0, 0, Alpha(3))
DX.SetVertex TileVert(4).Vertex(), 280, 200, 100, 100, DX.DX.CreateColorRGBA(Red(1), 0, 0, Alpha(2)), DX.DX.CreateColorRGBA(Red(0), 0, 0, Alpha(3))
DX.SetVertex TileVert(5).Vertex(), 140, 150, 100, 100, DX.DX.CreateColorRGBA(Red(1), 0, 0, Alpha(2)), DX.DX.CreateColorRGBA(Red(0), 0, 0, Alpha(3))
DX.SetVertex TileVert(6).Vertex(), 375, 100, 100, 100, DX.DX.CreateColorRGBA(Red(1), 0, 0, Alpha(2)), DX.DX.CreateColorRGBA(Red(0), 0, 0, Alpha(3))
DX.SetVertex TileVert(7).Vertex(), 230, 50, 100, 100
DX.Clear_Device
End Function

Public Function BLT()
DX.BackBuffer.BltColorFill DX.MakeRect(0, 0, 640, 480), 0
DX.BeginScene
DX.Blt3D FloorSurf, TileVert(1).Vertex()
DX.Blt3D DxLogo, TileVert(2).Vertex()
DX.Blt3D DxLogo, TileVert(3).Vertex()
DX.EnableBlendOne
DX.Blt3D FlareSurf, TileVert(4).Vertex()
DX.Blt3D FlareSurf, TileVert(5).Vertex()
DX.Blt3D FlareSurf, TileVert(6).Vertex()
DX.Blt3D FlareSurf, TileVert(7).Vertex()
DX.DisableBlendOne
DX.EndScene
End Function

Public Function ISoRotateVertex(Vertex() As D3DTLVERTEX, X As Integer, Y As Integer, Width As Integer, Height As Integer, Angle As Integer, Optional color1 As Long = &HFFFFFF, Optional color2 As Long = &HFFFFFF, Optional color3 As Long = &HFFFFFF, Optional color4 As Long = &HFFFFFF)
If Angle <= 1 Then
    Call DX.DX.CreateD3DTLVertex(X, Y, 0, 1, color1, 1, 0, 0, Vertex(0))
    Call DX.DX.CreateD3DTLVertex(X + Width + Width / 2, Y + Height / 2, 0, 1, color2, 1, 1, 0, Vertex(1))
    Call DX.DX.CreateD3DTLVertex(X - Width, Y + Height, 0, 1, color4, 1, 0, 1, Vertex(2))
    Call DX.DX.CreateD3DTLVertex(X + Width - Width / 2, Y + Height + Height / 2, 0, 1, color3, 1, 1, 1, Vertex(3))
ElseIf Angle = 2 Then
    Call DX.DX.CreateD3DTLVertex(X, Y - Height / Height, 0, 1, color1, 1, 0, 0, Vertex(0))
    Call DX.DX.CreateD3DTLVertex(X + Width + Width / 2, Y + (Height / 2), 0, 1, color2, 1, 1, 0, Vertex(1))
    Call DX.DX.CreateD3DTLVertex(X, Y + Height / 2 * 2 + Height / 2, 0, 1, color4, 1, 0, 1, Vertex(2))
    Call DX.DX.CreateD3DTLVertex(X + Width + Width / 2, Y + Height / 2 * 2 + Height, 0, 1, color3, 1, 1, 1, Vertex(3))
ElseIf Angle = 3 Then
    Call DX.DX.CreateD3DTLVertex(X - Width / 2, Y, 0, 1, color1, 1, 0, 0, Vertex(0))
    Call DX.DX.CreateD3DTLVertex(X + Width - Width / 2, Y - (Height), 0, 1, color2, 1, 1, 0, Vertex(1))
    Call DX.DX.CreateD3DTLVertex(X - Width / 2, Y + Height + Height / 2, 0, 1, color4, 1, 0, 1, Vertex(2))
    Call DX.DX.CreateD3DTLVertex(X + Width - Width / 2, Y + Height - Height / 2, 0, 1, color3, 1, 1, 1, Vertex(3))
End If
End Function
